#include <iostream>

struct vector3d {
	double x, y, z;

	void print() const {
		std::cout << '(' << x << ", " << y << ", " << z << ")\n";
	}

	// notice the symmetry
	friend vector3d operator+(const vector3d& a, const vector3d& b) {
		return { a.x + b.x, a.y + b.y, a.z + b.z };
	}
};

int main() {
	vector3d u = { 1, 2, 3 };
	vector3d v = { 0, 0, 7 };
	(u + v).print();
}
