#include <compare>
#include <iostream>

struct only_eq {
	int x, y;

	friend bool operator==(const only_eq&,
	                       const only_eq&) = default;
};

struct full {
	int x, y;

	friend auto operator<=>(const full&,
	                        const full&) = default;
};

void show_cmp(full a, full b) {
	std::cout << "-----------------"
	          << "\na = { " << a.x << ", " << a.y << " }"
	          << "\nb = { " << b.x << ", " << b.y << " }"
	          << "\na < b:  " << (a < b)
	          << "\na <= b: " << (a <= b)
	          << "\na == b: " << (a == b)
	          << "\na != b: " << (a != b)
	          << "\na >= b: " << (a >= b)
	          << "\na > b:  " << (a > b) << "\n-----------------\n";

}

int main() {
	only_eq a = { 1, 2 }, b = { 3, 4 };
	std::cout << (a == b) << ' ' << (a != b) << '\n';
	b = { 1, 2 };
	std::cout << (a == b) << ' ' << (a != b) << '\n';

	// a < b;  // error

	show_cmp({ 1, 2 }, { 3, 4 });
	show_cmp({ 1, 2 }, { 1, 4 });
	show_cmp({ 1, 2 }, { 1, 2 });
}
