#include <iostream>
#include <vector>

struct label {
	std::vector<char> letters = { 'A' };

	label& operator++() {  // prefix
		for (char& c : letters) {
			if (c != 'Z') {
				++c;
				return *this;
			}
			c = 'A';
		}
		letters.push_back('A');
		return *this;
	}

	label operator++(int) {  // postfix
		auto copy = *this;
		++*this;
		return copy;
	}

	void print() const {
		auto i = letters.size();
		while (i --> 0) {
			std::cout << letters[i];
		}
		std::cout << '\n';
	}
};

int main() {
	label lbl;
	for (int i = 0; i < 16383; ++i) {
		++lbl;
	}
	lbl.print();
	auto old = lbl++;
	lbl.print();
	old.print();
}
